<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Decryptor.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">astrapay-otp</a> &gt; <a href="index.source.html" class="el_package">com.astrapay.otp.util</a> &gt; <span class="el_source">Decryptor.java</span></div><h1>Decryptor.java</h1><pre class="source lang-java linenums">package com.astrapay.otp.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;
import java.security.spec.KeySpec;
import java.util.Base64;

@Component
public class Decryptor {

<span class="fc" id="L20">	private final Logger log = LoggerFactory.getLogger(this.getClass());</span>

<span class="fc" id="L22">	public Decryptor() {</span>
		
<span class="fc" id="L24">	}</span>
	
	public String encrypt(String strToEncrypt, String secretKeys,String salt)
	{
	    try
	    {
<span class="fc" id="L30">	        byte[] iv = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };</span>
<span class="fc" id="L31">	        IvParameterSpec ivspec = new IvParameterSpec(iv);</span>
	         
<span class="fc" id="L33">	        SecretKeyFactory factory = SecretKeyFactory.getInstance(&quot;PBKDF2WithHmacSHA256&quot;);</span>
<span class="fc" id="L34">	        KeySpec spec = new PBEKeySpec(secretKeys.toCharArray(), salt.getBytes(), 65536, 256);</span>
<span class="fc" id="L35">	        SecretKey tmp = factory.generateSecret(spec);</span>
<span class="fc" id="L36">	        SecretKeySpec secretKey = new SecretKeySpec(tmp.getEncoded(), &quot;AES&quot;);</span>
	        
<span class="fc" id="L38">	        Cipher cipher = Cipher.getInstance(&quot;AES/CBC/PKCS5Padding&quot;);</span>
<span class="fc" id="L39">	        cipher.init(Cipher.ENCRYPT_MODE, secretKey, ivspec);</span>
<span class="fc" id="L40">	        return Base64.getEncoder().encodeToString(cipher.doFinal(strToEncrypt.getBytes(StandardCharsets.UTF_8)));</span>
	    } 
<span class="nc" id="L42">	    catch (Exception e) </span>
	    {
<span class="nc" id="L44">	        log.error(e.getMessage());</span>
	    }
<span class="nc" id="L46">	    return null;</span>
	}
	
	public String decrypt(String strToDecrypt,String secretKeys,String salt) {
	    try
	    {
<span class="fc" id="L52">	        byte[] iv = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };</span>
<span class="fc" id="L53">	        IvParameterSpec ivspec = new IvParameterSpec(iv);</span>
	         
<span class="fc" id="L55">	        SecretKeyFactory factory = SecretKeyFactory.getInstance(&quot;PBKDF2WithHmacSHA256&quot;);</span>
<span class="fc" id="L56">	        KeySpec spec = new PBEKeySpec(secretKeys.toCharArray(), salt.getBytes(), 65536, 256);</span>
<span class="fc" id="L57">	        SecretKey tmp = factory.generateSecret(spec);</span>
<span class="fc" id="L58">	        SecretKeySpec secretKey = new SecretKeySpec(tmp.getEncoded(), &quot;AES&quot;);</span>
	         
<span class="fc" id="L60">	        Cipher cipher = Cipher.getInstance(&quot;AES/CBC/PKCS5PADDING&quot;);</span>
<span class="fc" id="L61">	        cipher.init(Cipher.DECRYPT_MODE, secretKey, ivspec);</span>
<span class="fc" id="L62">	        return new String(cipher.doFinal(Base64.getDecoder().decode(strToDecrypt)));</span>
	    } 
<span class="nc" id="L64">	    catch (Exception e) {</span>
<span class="nc" id="L65">	        System.out.println(&quot;Error while decrypting: &quot; + e.toString());</span>
	    }
<span class="nc" id="L67">	    return null;</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.5.201910111838</span></div></body></html>